{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":567,"path":"api-reference/rest-apis/versions-api.md","title":"CdmVersionApi","bundle":null,"doc_type":null,"release":"australia","body":"\n# CdmVersionApi\n\nThe CdmVersionApi provides endpoints that enable you to publish, unpublish, and export versions \\(snapshots\\) in Configuration Data Management \\(CDM\\) for shared components under shared libraries.\n\nYou publish a snapshot so that it can be exported, enabling the Continuous Integration and Continuous Delivery \\(CICD\\) pipeline to access and use the associated shared components and libraries. Exporters can only execute on published snapshots. When snapshots are no longer needed, you can unpublish them to reduce the confusion as to whether the snapshot is viable anymore.\n\nYou must have one of the following roles to access this API:\n\n-   Scripted REST CDM View ACL \\(sn\\_cdm.cdm.viewer\\)\n-   Scripted REST CDM Editor ACL \\(sn\\_cdm.cdm\\_editor\\)\n\nIn addition, the Configuration Data Management \\(CDM\\) plugin must be activated for this API to be available in an instance.\n\nFor additional information on snapshots, see [View snapshots](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-snapshots-view-list.md).\n\n**Parent Topic:**[REST API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/api-rest.md)\n\n## CdmVersionApi - GET /sn\\_cdm/versions/export\n\nReturns the configuration data for a specified shared component within a specified shared library for a specified published version.\n\nThe CDM Editor role is required to access this endpoint.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/versions/export`\n\nDefault URL: `/api/sn_cdm/versions/export`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ndataFormat\n\n</td><td>\n\nRequired. Format of the configuration data.Valid values:\n\n-   csv\n-   ini\n-   json\n-   properties\n-   raw\n-   xml\n-   yaml\n\nData type: String\n\n</td></tr><tr><td>\n\ndecryptPassword\n\n</td><td>\n\nFlag that indicates whether to show encoded or decrypted password values.Valid values:\n\n-   true: Decrypt password and show decrypted value.\n-   false: Show encrypted password value.\n\nDefault: false\n\n</td></tr><tr><td>\n\nsharedComponentName\n\n</td><td>\n\nRequired. Name of the shared component whose configuration data to export.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr><td>\n\nsharedLibraryName\n\n</td><td>\n\nRequired. Name of the shared library that contains the component whose configuration data you want to return. The specified application must have the type field set to \"shared\\_library\".Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nsubstituteVariables\n\n</td><td>\n\nFlag that indicates whether to follow the variables. For information on following the variables, see [Validating and correcting configuration data](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-validating-cfg-data.md).Valid values:\n\n-   true: Follow the variables.\n-   false: Do not follow variables.\n\nDefault: true\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"cdm_apps-sl_req_headers-accept-entry\">\n\nData format of the response body. Supported types:\n\n-   **application/json**\n-   **application/xml**\n-   **text/xml**\n\nDefault: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. One of the follow problems may have occurred:-   Shared library is not active.\n-   Shared component is not active.\n-   Version s not published.\n-   Parameter is missing in the call.\n\n</td></tr><tr><td>\n\n500\n\n</td><td id=\"entry-500-status-code\">\n\nInternal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nresult\n\n</td><td>\n\nConfiguration data in the specified format.\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nError status of the request.Possible values: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following code example shows how to export the configuration data of the \"jdk8\" component under the \"JavaLib\" shared library.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/shared_libraries/components/exports?sharedLibraryName=JavaLib&componentName=jdk8 \n--request POST \\  \n--header \"Accept:application/json\" \\   \n--user 'username':'password'\n```\n\nResponse:\n\n```\n{  \n\"result\": {  \n    \"sharedComponentA\": { \"cdi\": \"val\" } \n }  \n} \n```\n\n## CdmVersionApi - PUT /sn\\_cdm/versions/publish\n\nPublishes a version of a shared component under a specified shared library.\n\nThe CDM Editor role is required to access this endpoint.\n\n**Note:** Snapshots and versions are synonymous in meaning for this implementation.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/versions/publish`\n\nDefault URL: `/api/sn_cdm/versions/publish`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nRequired. Name of the version of the shared component to publish.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td>\n\nComma-separated list of fields in the CDM Snapshot \\[sn\\_cdm\\_snapshot\\] table to return as part of the response.Data type: String\n\nDefault: Returns all non-system fields.\n\n</td></tr><tr><td>\n\nsharedComponentName\n\n</td><td>\n\nRequired. Name of the shared component to publish.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr><td>\n\nsharedLibraryName\n\n</td><td>\n\nRequired. Name of the shared library in which the specified component resides. The type field in the associated record must be set to \"shared\\_library\".Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"cdm_apps-sl_req_headers-accept-entry\">\n\nData format of the response body. Supported types:\n\n-   **application/json**\n-   **application/xml**\n-   **text/xml**\n\nDefault: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. Error occurred during publishing.Possible issues:\n\n-   Version name not found.\n-   Component version is already published.\n\n</td></tr><tr><td>\n\n500\n\n</td><td id=\"entry-500-status-code\">\n\nInternal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table id=\"id_rtv_wbb_fwb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncdm\\_application\\_id\n\n</td><td>\n\nDetails about the CDM application associated with the snapshot.Data type: Object\n\n```\n\"cdm_application_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_application\\_id.link\n\n</td><td>\n\nCall to use to access the CDM application record using the REST Table API. Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_application\\_id.value\n\n</td><td>\n\nSys\\_id of the associated CDM application record.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id\n\n</td><td>\n\nDetails about the CDM deployable associated with the snapshot.Data type: Object\n\n```\n\"cdm_deployable_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id.link\n\n</td><td>\n\nCall syntax for querying this deployable record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id.value\n\n</td><td>\n\nSys\\_id of the deployable record.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nDetails about the changeset associated with the snapshot.Data type: Object\n\n```\n\"changeset_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nchangeset\\_id.link\n\n</td><td>\n\nCall syntax for querying this changeset record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\nchangeset\\_id.value\n\n</td><td>\n\nUnique identifier of the changeset record.Data type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nBrief description of the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nlast\\_published\n\n</td><td>\n\nDate and time that the snapshot was last published.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nlast\\_validated\n\n</td><td>\n\nDate and time that the snapshot was last validated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique number that identifies the snapshot. This value provides a human-readable identifier for the mapping.Data type: String\n\n</td></tr><tr><td>\n\npublished\n\n</td><td>\n\nFlag that indicates whether the snapshot was published.Possible values:\n\n-   true: Snapshot was published.\n-   false: Snapshot wasn't published.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nName of the user that created the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the snapshot was created.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the snapshot.Data type: String\n\nTable: CDM Snapshot \\[sn\\_cdm\\_snapshot\\]\n\n</td></tr><tr><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nName of the user that updated the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the snapshot was last updated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nvalidation\n\n</td><td>\n\nCurrent validation state of the snapshot. Possible values:\n\n-   execution\\_error\n-   failed\n-   in\\_progress\n-   not\\_validated\n-   passed\n-   passed\\_with\\_exception\n-   requested\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis code example shows how to publish the shared component \"Development\" with the version name of \"Development-v1.shc\".\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/versions/publish?sharedLibraryName=LibraryJdk&componentName=Development&name=Development-v1.shc\" \\  \n--request PUT\\  \n--header \"Accept:application/json\" \\  \n--user 'username':'password\n```\n\nResponse:\n\n```\n{\n  \"result\": {\n    \"changeset_id\": {\n      \"value\": \"1a2bd15c7764a1109ac0cf0bbb5a99fc\",\n      \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_changeset/1a2bd15c7764a1109ac0cf0bbb5a99fc\"\n    },\n    \"cdm_deployable_id\": null,\n    \"cdm_shared_component_node_id\": {\n      \"value\": \"fe2b155c7764a1109ac0cf0bbb5a995d\",\n      \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_node/fe2b155c7764a1109ac0cf0bbb5a995d\"\n    },\n    \"cdm_shared_component_id\": {\n      \"value\": \"362b155c7764a1109ac0cf0bbb5a9970\",\n      \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_shared_component/362b155c7764a1109ac0cf0bbb5a9970\"\n    },\n    \"description\": null,\n    \"cdm_application_id\": {\n      \"value\": \"122bd15c7764a1109ac0cf0bbb5a99fa\",\n      \"link\": \"http://instance.servicenow.com/api/now/table/sn_cdm_application/122bd15c7764a1109ac0cf0bbb5a99fa\"\n    },\n    \"published\": true,\n    \"sys_updated_on\": \"2023-01-18 14:15:44\",\n    \"last_published\": \"2023-01-18 09:53:37\",\n    \"sequence_number\": \"1\",\n    \"number\": \"SNAP0001110\",\n    \"sys_id\": \"df2b155c7764a1109ac0cf0bbb5a9949\",\n    \"sys_updated_by\": \"admin\",\n    \"sys_created_on\": \"2023-01-18 09:53:36\",\n    \"name\": \"logonService-V2.1-v1.shc\",\n    \"last_validated\": \"\",\n    \"validation\": \"passed\",\n    \"sys_created_by\": \"admin\"\n  }\n}\n```\n\n## CdmVersionApi - PUT /sn\\_cdm/versions/unpublish\n\nUnpublishes a version of a shared component under a specified shared library.\n\nThe CDM Editor role is required to access this endpoint.\n\n**Note:** Snapshots and versions are synonymous in meaning for this implementation.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/versions/publish`\n\nDefault URL: `/api/sn_cdm/versions/publish`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nRequired. Name of the version of the shared component to unpublish.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td>\n\nComma-separated list of fields in the CDM Snapshot \\[sn\\_cdm\\_snapshot\\] table to return as part of the response.Data type: String\n\nDefault: Returns all non-system fields.\n\n</td></tr><tr><td>\n\nsharedComponentName\n\n</td><td>\n\nRequired. Name of the shared component to unpublish.Data type: String\n\nTable: CDM Shared Component \\[sn\\_cdm\\_shared\\_component\\]\n\n</td></tr><tr><td>\n\nsharedLibraryName\n\n</td><td>\n\nRequired. Name of the shared library in which the specified component resides. The type field in the associated record must be set to \"shared\\_library\".Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"cdm_apps-sl_req_headers-accept-entry\">\n\nData format of the response body. Supported types:\n\n-   **application/json**\n-   **application/xml**\n-   **text/xml**\n\nDefault: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table><thead><tr><th>\n\nStatus code\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\n200\n\n</td><td id=\"entry-200-status-code\">\n\nSuccessful. The request was successfully processed.\n\n</td></tr><tr><td>\n\n400\n\n</td><td>\n\nBad Request. Error occurred during unpublishing.Possible issues:\n\n-   Version name not found.\n-   Component version is already published.\n\n</td></tr><tr><td>\n\n500\n\n</td><td id=\"entry-500-status-code\">\n\nInternal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.\n\n</td></tr></tbody>\n</table>### Response body parameters\n\n<table id=\"id_mbl_2cb_fwb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncdm\\_application\\_id\n\n</td><td>\n\nDetails about the CDM application associated with the snapshot.Data type: Object\n\n```\n\"cdm_application_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_application\\_id.link\n\n</td><td>\n\nCall to use to access the CDM application record using the REST Table API. Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_application\\_id.value\n\n</td><td>\n\nSys\\_id of the associated CDM application record.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id\n\n</td><td>\n\nDetails about the CDM deployable associated with the snapshot.Data type: Object\n\n```\n\"cdm_deployable_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id.link\n\n</td><td>\n\nCall syntax for querying this deployable record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\ncdm\\_deployable\\_id.value\n\n</td><td>\n\nSys\\_id of the deployable record.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\nchangeset\\_id\n\n</td><td>\n\nDetails about the changeset associated with the snapshot.Data type: Object\n\n```\n\"changeset_id\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nchangeset\\_id.link\n\n</td><td>\n\nCall syntax for querying this changeset record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\nchangeset\\_id.value\n\n</td><td>\n\nUnique identifier of the changeset record.Data type: String\n\nTable: CDM Changeset \\[sn\\_cdm\\_changeset\\]\n\n</td></tr><tr><td>\n\ndescription\n\n</td><td>\n\nBrief description of the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nlast\\_published\n\n</td><td>\n\nDate and time that the snapshot was last published.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nlast\\_validated\n\n</td><td>\n\nDate and time that the snapshot was last validated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique number that identifies the snapshot. This value provides a human-readable identifier for the mapping.Data type: String\n\n</td></tr><tr><td>\n\npublished\n\n</td><td>\n\nFlag that indicates whether the snapshot was published.Possible values:\n\n-   true: Snapshot was published.\n-   false: Snapshot wasn't published.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nName of the user that created the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the snapshot was created.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the snapshot.Data type: String\n\nTable: CDM Snapshot \\[sn\\_cdm\\_snapshot\\]\n\n</td></tr><tr><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nName of the user that updated the snapshot.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the snapshot was last updated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nvalidation\n\n</td><td>\n\nCurrent validation state of the snapshot. Possible values:\n\n-   execution\\_error\n-   failed\n-   in\\_progress\n-   not\\_validated\n-   passed\n-   passed\\_with\\_exception\n-   requested\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following code example shows how to unpublish the \"paymentService-V1\" shared component from the \"OracleG-Library-10\" shared library.\n\n```\ncurl \"https://instance-name.service-now.com/api/sn_cdm/versions/unpublish?sharedLibraryName=OracleG-Library-10&sharedComponentName=paymentService-V1.1&name=paymentService-V1.1-v1.shc\" \\ \n--request PUT \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nResponse:\n\n```\n{\n  \"result\": {\n    \"changeset_id\": {\n      \"value\": \"1a2bd15c7764a1109ac0cf0bbb5a99fc\",\n      \"link\": \"http://192.168.0.129:8080/api/now/table/sn_cdm_changeset/1a2bd15c7764a1109ac0cf0bbb5a99fc\"\n    },\n    \"cdm_deployable_id\": null,\n    \"cdm_shared_component_node_id\": {\n      \"value\": \"fe2b155c7764a1109ac0cf0bbb5a995d\",\n      \"link\": \"http://192.168.0.129:8080/api/now/table/sn_cdm_node/fe2b155c7764a1109ac0cf0bbb5a995d\"\n    },\n    \"cdm_shared_component_id\": {\n      \"value\": \"362b155c7764a1109ac0cf0bbb5a9970\",\n      \"link\": \"http://192.168.0.129:8080/api/now/table/sn_cdm_shared_component/362b155c7764a1109ac0cf0bbb5a9970\"\n    },\n    \"description\": null,\n    \"cdm_application_id\": {\n      \"value\": \"122bd15c7764a1109ac0cf0bbb5a99fa\",\n      \"link\": \"http://192.168.0.129:8080/api/now/table/sn_cdm_application/122bd15c7764a1109ac0cf0bbb5a99fa\"\n    },\n    \"published\": false,\n    \"sys_updated_on\": \"2023-01-18 14:15:44\",\n    \"last_published\": \"2023-01-18 09:53:37\",\n    \"sequence_number\": \"1\",\n    \"number\": \"SNAP0001110\",\n    \"sys_id\": \"df2b155c7764a1109ac0cf0bbb5a9949\",\n    \"sys_updated_by\": \"admin\",\n    \"sys_created_on\": \"2023-01-18 09:53:36\",\n    \"name\": \"logonService-V2.1-v1.shc\",\n    \"last_validated\": \"\",\n    \"validation\": \"passed\",\n    \"sys_created_by\": \"admin\"\n  }\n}\n```\n\n"}}